'''
Created on 23 oct. 2012

@author: coissac
'''
from orgasm.indexer import _orgasm as indexer
from orgasm import samples
from orgasm.assembler import Assembler
from orgasm.graph import  pathIterator 
from orgasm.backtranslate.fasta import fasta
from orgasm.assembler._asmbgraph import AsmbGraph

import sys
import time
import math
import cPickle

#if __name__ == '__main__':
p = fasta('../../samples/arabidopsis.chloro.prot.fasta')
p2=dict(x for x in p.items() if x[0] not in ['ycf2'])

gp = ['rbcL','matK','psbA','ndhA','rpoA','atpA']
p2=dict(x for x in p.items() if x[0] in gp)

r = indexer.Index('../../samples/locontella')
x = r.lookForSeeds(p)

# Assemblage de Polypodium vulgare (Q)

from orgasm.indexer import _orgasm as indexer
from orgasm.assembler import Assembler
from orgasm.backtranslate.fasta import fasta

import sys
from orgasm.tango import *

p = fasta('../../samples/arabidopsis.chloro.prot.fasta')
gp = ['rbcL','matK','ndhA','rpoA','atpA','atpH','rpoA','atpB','psbN',
 'psbT',
 'psbB',
 'psbD',
 'psbE',
 'psbF',
 'psbA',
 'psbC',
 'psbM',
 'psbI',
 'psbH',
 'psbK',
 'psbJ',
 'psbL',
 'psbZ']
p2=dict(x for x in p.items() if x[0] in gp)

r = indexer.Index('../../samples/AA')
x = r.lookForSeeds(p2)

asm = Assembler(r)
s = matchtoseed(x,r)
a = tango(asm,s,mincov=1,minread=20,minoverlap=50)

cutLowCoverage(asm,300)
cutLowCoverage(asm,300,False)

cg = asm.compactAssembling()

scaffold(cg,r)
print >>open('AA.clean.gml','w'),cg.gml()

s=[(-abs(i),(None,)) for i in asm.startNodeSet() | asm.endNodeSet()]
s=[(-abs(i),(None,)) for i in asm.graph]

a = tango(asm,s,mincov=1,minread=5,minoverlap=20,restrict=asm.graph)

asm.cleanDeadBranches()
cutLowCoverage(asm,10,r)
asm.cleanDeadBranches()
# or

while (1):
    s=[(-abs(i),(None,)) for i in asm.startNodeSet() | asm.endNodeSet()]
    a = tango(asm,s,mincov=1,minread=12,minoverlap=24)
    asm.cleanDeadBranches()
    cutLowCoverage(asm,10,r)
    asm.cleanDeadBranches()
    cutLowCoverage(asm,100,r)
    asm.cleanDeadBranches()
    cutLowCoverage(asm,400,r)
    asm.cleanDeadBranches()
    cg = asm.compactAssembling()
    scaffold(cg,r)
    print >>open('Q.clean.gml','w'),cg.gml()
    
cg = asm.compactAssembling()

                           

s=dict((r.getIds(y[0])[0],('rbcL',)) for y in x['rbcL'])
a = tango(asm,s,r)

x = cPickle.load(open('match.dict.pickle'))

asm = Assembler(r)

a = tango(asm,s,r,mincov=1,minread=20,minoverlap=80)
a = tango(asm,s,r,mincov=1,minread=40,minoverlap=40) # ok pour lecontella
a = tango(asm,s,r,mincov=1,minread=10,minoverlap=40) # ok pour sartidia
a = tango(asm,s,r,mincov=1,minread=10,minoverlap=25) # ok pour machaon
asm.run()

asm.simplifyAssembly()

sg = asm.compactAssembling()

print>>open('lecontella.dot','w'), sg


def ssnode(n):
    n = asm.graph.getNodeAttr(n)
    return False if 'singlestep' not in n else n['singlestep']

def ssedge(e):
    n = asm.graph.getEdgeAttr(e[0],e[1])
    return False if 'singlestep' not in n else n['singlestep']

def is_input(e):
    return len([x for x in asm.graph.parentIterator(e,ssnode,ssedge)])==0
    
def is_output(e):
    return len([x for x in asm.graph.neighbourIterator(e,ssnode,ssedge)])==0
    

def ioIterator(lmin=1):
    for cc in asm.graph.connectedComponentIterator(ssnode,ssedge):
        if len(cc)>=lmin:
            i = set(x for x in cc if is_input(x))
            o = set(x for x in cc if is_output(x))
            yield i,o
        

def notssedge(e):
    n = asm.graph.getEdgeAttr(e[0],e[1])
    return True if 'singlestep' not in n else not n['singlestep']

def notssnode(n):
    no = asm.graph.getNodeAttr(n)
    return (True if 'singlestep' not in no else not no['singlestep'] ) or n in innodes


        
def scoreedge(a,b):
    e = asm.graph.getEdgeAttr(a,b)
    n = asm.graph.getNodeAttr(b)
    return float(len(e['label']))/float(n['weight'])
    

asm.markOneStepPath()
i=ioIterator()
x=[y for y in i]
innodes=reduce(lambda a,b:a|b[0],(m for m in x),set())
outnodes=reduce(lambda a,b:a|b[1],(m for m in x),set())

for b in outnodes:
    path = asm.graph.minpath(b,
                              innodes,
                              scoreedge,
                              nodePredicate=notssnode,edgePredicate=notssedge)
    if path[0]:
        for p in pathIterator(path[0],path[1]):
            print p
            start = p.pop(0)
            print start
            for n in p:
                e = asm.graph.getEdgeAttr(start,n)
                e['singlestep']=True
                e[b'color']=b'blue'
                node = asm.graph.getNodeAttr(n)
                node['singlestep']=True
                node[b'color']=b'blue'
                start=n
                                    
notblue = [x for x in asm.graph if not ssnode(x)]

for n in notblue:
    asm.graph.deleteNode(n)
    
be = [x for x in asm.graph.edgeIterator(edgePredicate=notssedge)]

for e in be:
    asm.graph.deleteEdge(*e)

asm.simplifyAssembly()

cg = asm.compactAssembling()

print >>open('toto3.gml','w'),cg.gml()


        
def weightStat(cg):
    w=[]
    for e in cg.edgeIterator():
        a = cg.getEdgeAttr(*e)
        w.append(a['weight'])
    return w
    
    
def fullWeightStat(asm,minl=20):
    w=[]
    
    for s in asm.stemIterator():
        if len(s[4]) > minl:
            weight=sum(asm.graph[x]['weight'] for x in s[4]) / float(s[2])
            w.append(weight)
    return w
            
    
    

from orgasm import graph 

g = graph.DiGraph('toto')
g.addEdge(1,2)
g.addEdge(1,3)
g.addEdge(3,4)
g.addEdge(4,2)
g.addEdge(2,5)
d,p = g.minpath(1)
pi=graph.pathIterator(d,p)
g.maxpath(1)


def cleanEdge(assemble):
    cleaned = set()
    
    start = assemble.startread
    
    loop = True
    starts = [start]
    n=0
    
    while loop:
        nextstart=[]
        for s in starts:
            n+=1
            print >>sys.stderr,"Cycle : %d ==> Cleanning node %d\r" % (n,s)
            cleaned.add(s)
            if s in asm.graph:
                e = [x for x in assemble.graph.neighbourIterator(s)]
                if len(e)>1:
                    ll= [len(assemble.graph[(s,x)]['label']) for x in e]
                    minll = min(ll)
                    de = [x for x in e if len(assemble.graph[(s,x)]['label']) > minll]
                    print >>sys.stderr,"Removes %d edges\r" % len(de), 
                    for x in de:
                        assemble.graph.deleteEdge(s,x)
                    assemble.cleanDeadBranches()
                nextstart.extend([x for x in assemble.graph.neighbourIterator(s) if x not in cleaned])
        starts = set(nextstart)
        loop = starts and (start not in starts)
        
    
        
def tango(self,index,proofreading=10,maxextension=5):
    
    def cmpPoints(p1,p2):
        rep = cmp(p1[0],p2[0])
        if not rep:
            rep= cmp(p1[3],p2[3])
        return rep
            
    def cmpKeys(k1,k2):
        return cmp(len(k2),len(k1))
    
    # un point d'extension is : 
    #           - the length of the path to the start read
    #           - the sequence to use as probe
    #           - the readid on the ending node
    #           - the weight of the node
    points = [(index.getReadSize(),
               e[0],
               e[1],
               self.graph[e[1]]['weight']) for e in self.extensions]
    
    cycle=0
    
    while(points):
        cycle+=1

        points.sort(cmpPoints)
        running = points.pop()
        extensions={}
        extlength=1
        length,read,nodeindex,w = running

        print >>sys.stderr,b"Cycle : %8d     Waiting points : %8d (%d bp)\r" % (cycle,len(points),length),
   
        while not extensions and extlength <= maxextension :
            probe = read[extlength:]
            extensions = index.getExtensions(probe)
            extlength+=1
                     
        if not extensions:
            erroron=nodeindex
            print >>sys.stderr,b"\nproof reading"
            extlength=0
            back=0
            probe=read
            while not extensions and back <= proofreading:
                fathers = [x for x in self.graph.parentIterator(nodeindex,
                                                    edgePredicate=lambda e : self.graph.getEdgeAttr(e[0],e[1])[b'type']==b"next read")]
                
                print "fathers = ",fathers
                xxx=nodeindex
                for f in fathers:
                    label = self.graph.getEdgeAttr(f,xxx)[b'label']
                    llabel=len(label)
                    print probe
                    print f,nodeindex,label,probe[-llabel:],extlength
                    #time.sleep(1)
                    if probe[-llabel:]==label: 
                        back+=llabel
                        print "ok",back                 
                        probe = index.getRead(f,back,index.getReadSize()-back)
                        extensions = index.getExtensions(probe)
                        k = extensions.keys()
                        print "raw extension",extensions

                        for e in k:
                            if erroron in extensions[e][1]:
                                print "remove idem"
                                del extensions[e]
                        nodeindex = f
                        extlength+=1
                        print extensions
                        

        for ex in extensions:
            data = extensions[ex]
            reads = self.readType(data[1])
            nodeindexE = reads[0]
            
            if nodeindexE==self.startread:
                print >>sys.stderr,b"\nLooping over start read %d " % (self.startread)
           
            alreadyin = nodeindexE in asm.graph
            self.graph.addEdge(nodeindex, nodeindexE)
            #self._finalread=nodeindexE
            
            attr = self.graph.getNodeAttr(nodeindexE)
            attr[b"weight"]=reads[1]
            attr[b"reads"]=reads[2]
            attr[b"position"]=length+len(ex)
            
            
            attr = self.graph.getEdgeAttr(nodeindex, nodeindexE)
            attr[b"label"]=ex
            attr[b"arrowsize"]=float(reads[1])/10
            attr[b"type"]=b"next read"
            
            if not alreadyin:
                points.append((length + len(ex),
                               index.getRead(reads[0],0,index.getReadSize()),
                               nodeindexE,
                               reads[1]))
                    
                


    
def commonOverlapIndexOf(text1, text2):  
    # Cache the text lengths to prevent multiple calls.
    text1_length = len(text1)
    text2_length = len(text2)
    # Eliminate the null case.
    if text1_length == 0 or text2_length == 0:
        return 0
    # Truncate the longer string.
    if text1_length > text2_length:
        text1 = text1[-text2_length:]
    elif text1_length < text2_length:
        text2 = text2[:text1_length]
    # Quick check for the worst case.
    if text1 == text2:
        return min(text1_length, text2_length)

    # Start by looking for a single character match
    # and increase length until no match is found.
    best = 0
    length = 1
    while True:
        pattern = text1[-length:]
        found = text2.find(pattern)
        if found == -1:
            return best
        length += found
        if text1[-length:] == text2[:length]:
            best = length
            length += 1
            

def tango(self,index, 
          minread=20, minratio=0.1, 
          mincov=2, minoverlap=40, 
          extlength=1, cleanBranch=False):
    '''
    
    :param index: the read index
    :type index:
    :param minread: 
    :type minread:
    :param minratio:
    :type minratio:
    :param mincov:
    :type mincov:
    :param minoverlap:
    :type minoverlap:
    :param extlength:
    :type extlength:
    '''
    
    def cmpPoints(p1,p2):
        rep = cmp(p2[0],p1[0])
        if not rep:
            rep= cmp(p1[4],p2[4])
        return -rep
            
    def cmpKeys(k1,k2):
        return cmp(len(k2),len(k1))
    
    def isEnd(node):
        s = [x for x in self.graph.neighbourIterator(node,edgePredicate=lambda e : self.graph.getEdgeAttr(e[0],e[1])[b'type']==b"next read")]
        f = [x for x in self.graph.parentIterator(node,edgePredicate=lambda e : self.graph.getEdgeAttr(e[0],e[1])[b'type']==b"next read")]
        if len(s)==0 and len(f)==1:
            return f[0]
        return 0
    
    readlength = index.getReadSize()

    # un point d'extension is : 
    #           - the length of the path to the start read
    #           - insertion since last read
    #           - the sequence to use as probe
    #           - the readid on the ending node
    #           - the weight of the node
    points = [(readlength,
               0,
               index.getRead(e[1],1,readlength-1),
               e[1],
               self.graph[e[1]]['weight']) for e in self.extensions]
    
    cycle=0
    extraid = int(10**math.ceil(math.log10(len(r)))) + 1
    shiftid = extraid
    tobacktrack = []
    lmax=0
    totreads=0
    
    while(points):
        cycle+=1

        points.sort(cmpPoints)
        running = points.pop()
        extensions={}
        extlength=1
        length,noreads,probe,nodeindex,w = running
        lmax = max(lmax,length)
        print >>sys.stderr,b"Cycle : %8d  (%d nodes / %d reads)   Waiting points : %8d (%d bp / %d bp) -- back : %d\r" % (cycle,len(asm.graph),totreads,len(points),length,lmax,len(tobacktrack)),
   
        attr =  self.graph.getNodeAttr(nodeindex) 
        #read = index.getRead(nodeindex,0,readlength)
        
        #
        # Try to deal with homopolymer by stopping elongation
        #
        
        if probe=="A" * len(probe) : 
            extensions={}
#            extensions = {'C':(1,[]),'G':(1,[]),'T':(1,[])}
        elif probe=="C" * len(probe) : 
            extensions={}
#            extensions = {'A':(1,[]),'G':(1,[]),'T':(1,[])}
        elif probe=="G" * len(probe) : 
            extensions={}
#            extensions = {'C':(1,[]),'A':(1,[]),'T':(1,[])}
        elif probe=="T" * len(probe) : 
            extensions={}
#            extensions = {'C':(1,[]),'G':(1,[]),'A':(1,[])}
        else:
            extensions = index.checkedExtensions(probe, minread=minread, minratio=minratio, mincov=mincov, minoverlap=minoverlap, extlength=extlength)

    #    print "\n",nodeindex," ++> ",extensions
        if not extensions and cleanBranch:
            f = isEnd(nodeindex)
            while(f):
                del self.graph[nodeindex]
                nodeindex=f
                f = isEnd(nodeindex)
            
    
        for ex in extensions:
            data = extensions[ex]
            if data[1]:
                reads = self.readType(data[1])
                nodeindexE = reads[0]
                
                #
                # A read cannot link to itself
                # --> homopolymer longer than the read length
                #
                if nodeindexE==nodeindex:
                    continue
            else:
                nodeindexE = extraid
                extraid+=1
            
            if nodeindexE==self.startread:
                print >>sys.stderr,b"\nLooping over start read %d " % (self.startread)
           
            alreadyin = nodeindexE in asm.graph
            self.graph.addEdge(nodeindex, nodeindexE)
            #self._finalread=nodeindexE
            
            attr = self.graph.getNodeAttr(nodeindexE)
            if nodeindexE >= shiftid:
                attr[b"label"]=''
                attr[b'graphics']={b'fill':'#008000',
                                   b'type':'rectangle'}     
                noreads+=1       
            else:
                attr[b"label"]='%d (%d)' %(nodeindexE,reads[1])
                attr[b"weight"]=reads[1]
                attr[b"reads"]=reads[2]
                totreads+=1
                noreads=0 
                            
            attr[b"position"]=length+len(ex)
            
            
            attr = self.graph.getEdgeAttr(nodeindex, nodeindexE)
            attr[b"label"]='%s [%d] (%d)' %(ex,length+len(ex),data[0])
            attr[b'sequence']=ex
            attr[b"type"]=b"next read"
            attr[b"coverage"]=data[0]
            attr['graphics']={'width':math.ceil(math.log(data[0])/math.log(2)),
                              'arrow':'last'}            
           
            if not alreadyin and noreads < (readlength - minoverlap):
                points.append((length + len(ex),
                               noreads,
                               probe[1:]+ex,
                               nodeindexE,
                               data[0]))
                    
                
       

    
def cpe(self,probe):
    extension=self.getExtensions(probe)
    allreadids = [extension[k][1] for k in extension]
    lp = len(probe)
    for x in allreadids:
        for y in x:
            p = self.getRead(y,0,lp)
            assert p==probe,"\nProbe : %s\nRep   : %s\n\n%s" % (probe,p,extension)
    return extension 


def coverageEstimate(prot,match,lread=100,minscore=15):
    cov={}
    
    for k in prot:
        lprot = len(prot[k]) * 3
        basecount = 0
        if k in match:
            for m in match[k]:
                if m[1] >=minscore:
                    basecount+=lread * m[2]
        cov[k]=float(basecount) / lprot 
        
    return cov



    
    
x={'rpl14': [(2573766, 18, 2, 1, 0.0),
  (-3397517, 16, 3, -3, 0.0),
  (-9351610, 16, 2, -2, 0.0),
  (11206729, 16, 2, 1, 0.0),
  (-13075047, 16, 2, -2, 0.0),
  (14685869, 18, 2, 0, 0.0),
  (14999159, 17, 2, 0, 0.0)],
 'rpl16': [(-909221, 22, 3, -2, 0.0),
  (2094043, 17, 2, 2, 0.0),
  (-3759908, 19, 2, -2, 0.0),
  (-5946274, 17, 3, -3, 0.0),
  (8126977, 16, 2, 1, 0.0),
  (9588507, 21, 2, 1, 0.0),
  (10738816, 19, 3, 2, 0.0)],
 'rpl2': [(236866, 16, 2, 0, 0.0),
  (1928532, 16, 2, 0, 0.0),
  (5706417, 16, 10, 2, 0.0),
  (5782045, 16, 3, 1, 0.0),
  (8196126, 19, 2, 2, 0.0),
  (8244020, 19, 3, 2, 0.0),
  (-8296859, 19, 2, -2, 0.0),
  (-8298962, 18, 3, -2, 0.0),
  (-8535070, 19, 4, -3, 0.0),
  (8626832, 18, 3, 2, 0.0),
  (-9342483, 16, 2, -1, 0.0),
  (-9456051, 17, 2, -3, 0.0),
  (11173582, 16, 5, 2, 0.0),
  (-13132160, 19, 2, -2, 0.0),
  (-16455865, 17, 3, -3, 0.0),
  (16919446, 17, 2, 2, 0.0)],
 'rps12': [(862750, 18, 2, 1, 0.0),
  (-2207684, 17, 3, -2, 0.0),
  (-2745111, 18, 2, -1, 0.0),
  (4889605, 18, 2, 2, 0.0),
  (5064189, 16, 2, 2, 0.0),
  (5211803, 18, 2, 0, 0.0),
  (5254975, 17, 2, 2, 0.0),
  (-7094217, 20, 2, -3, 0.0),
  (7402069, 22, 2, 2, 0.09981524629190291),
  (-7464726, 17, 2, -3, 0.0),
  (-7881444, 17, 2, -3, 0.0),
  (7976243, 16, 3, 2, 0.0),
  (8431545, 19, 2, 1, 0.0),
  (8436186, 22, 4, 1, 0.09981524629190291),
  (10449608, 16, 5, 1, 0.0),
  (10524565, 17, 2, 0, 0.0),
  (-13424151, 18, 2, -2, 0.0),
  (-13495209, 16, 3, -1, 0.0),
  (15071790, 16, 2, 1, 0.0)],
 'rps2': [(62453, 16, 2, 2, 0.0),
  (160869, 16, 2, 1, 0.0),
  (412778, 18, 3, 1, 0.0),
  (-1151828, 18, 3, -1, 0.0),
  (1442154, 18, 4, 1, 0.0),
  (-2871339, 18, 3, -2, 0.0),
  (2918339, 18, 5, 2, 0.0),
  (3042383, 17, 4, 1, 0.0),
  (4342413, 18, 2, 0, 0.0),
  (-10087325, 16, 2, -2, 0.0),
  (-11357851, 18, 3, -2, 0.0),
  (11941870, 18, 4, 2, 0.0),
  (-13024299, 18, 2, -2, 0.0),
  (-13786786, 18, 4, -1, 0.0),
  (-14048126, 18, 2, -3, 0.0),
  (15505340, 18, 2, 2, 0.0),
  (16782797, 18, 2, 2, 0.0)],
 'rps4': [(564720, 17, 2, 1, 0.0),
  (-1176979, 19, 2, -1, 0.0),
  (-2960382, 17, 2, -2, 0.0),
  (7102274, 16, 2, 1, 0.0),
  (-8195121, 18, 2, -2, 0.0),
  (8371520, 16, 3, 1, 0.0),
  (-8517970, 17, 2, -2, 0.0),
  (-9898537, 17, 3, -3, 0.0),
  (11426723, 18, 3, 1, 0.0),
  (13103212, 19, 2, 2, 0.0),
  (-14729273, 16, 2, -2, 0.0)]}


def testIndex(r):
    from obitools import NucSequence
    from obitools.utils import progressBar as pb
    nbseq = len(r)
    rsize =  r.getReadSize()
    
    pb(1,nbseq,1)
    
    for i in xrange(1,nbseq+1):
        cseq = str(NucSequence('xxx',r.getRead(i,0,rsize)).complement()).upper()
        rseq = r.getRead(-i,0,rsize)
        pb(i,nbseq)
        if cseq!=rseq:
            print "problem with read : %d" %i
            print "   %s",cseq 
            print "   %s",rseq
            print
            
s=dict((r.getIds(y[0])[0],('rbcL',)) for y in x['rbcL'])
    
                  
    
     

def distPaired(x,p,index):
    dist = []
    lindex = len(index)
    i = p[x]
    pp = [index.getIds(index.getPairedRead(j))[0] for j in index.getIds(i)[2] if j <=lindex and j > 0]
    
    for j in pp:
        try:
            p1=p.index(j,x)
        except ValueError:
            p1=-1
            
        if p1 < 0:
            try:
                p1=p.index(-j,x)
            except ValueError:
                pass
        if p1 > 0:
            p1 = p1 - x   
            dist.append(p1) 
            
    return dist

p = cg.getEdgeAttr(27099517, 100005265, 0)['path']
d = reduce(lambda a,b:a+b,(distPaired(i,p,r) for i in range(len(p))))


def cutParallel(self,mincov):
    index = self.index
    stems = [x for x in self.stemIterator(alllink=False)]
    readSize = index.getReadSize()
    stemparallel ={}
    for first, last, lseq, sequence, path in stems:
        weight = sum(self.graph[x]['coverage'] for x in path if x in self.graph and 'coverage' in self.graph[x]) / float(len(path)) * readSize
        s = (first, last)
        ls = stemparallel.get(s,[])
        ls.append((first, last, lseq, sequence, path,weight))
        stemparallel[s]=ls
    spis = stemparallel.keys()
    for spi in spis:
        if len(stemparallel[spi]==1):
            del stemparallel[spi]
    return stemparallel
    


def fillGaps(self,minlink=5,back=200,kmer=12,smin=40,delta=2):
    assgraph = self.compactAssembling()
    index = self.index
    e = [i for i in assgraph.edgeIterator(edgePredicate=lambda e: 'stemid' in assgraph.getEdgeAttr(*e))]
    eid = [assgraph.getEdgeAttr(*i)['stemid'] for i in e]
    ne = len(e)
    s=[]
    for e1 in xrange(ne):
        for e2 in xrange(ne):
            connected = e[e1][1]==e[e2][0]
            if not connected:
                linkedby  = pairEndedConnected(self,assgraph, eid[e1], eid[e2], back)
            
                if linkedby >= minlink:
                    ex = getPairedRead(self,assgraph,eid[e1],back,end=True)
                    exr= getPairedRead(self,assgraph,eid[e2],back,end=False)
                    ex = ex | exr
                    nreads = len(ex)
                    ali= multiAlignReads(ex,index,kmer,smin,delta)
                    goodali = [i for i in ali if len(i) >= nreads/4]
                    
                    for a in goodali:
                        c = consensus(a,index)
                        s = insertFragment(self,c)
                        
                    
from orgasm.indexer._orgasm import Index
from orgasm.multialign import *, consensus
from orgasm.tango import *
from orgasm.assembler import Assembler

r = Index('/Users/coissac/travail/NextGen/mito/bos-torus/ftp.1000genomes.ebi.ac.uk/data/UGBT/UGBT-B8-0101/sequence_read/UGBT-B8-0101')
readsid=set([-931327,
     -3525629,
     -25923575,
     -19998710,
     -7769073,
     -18697712,
     -15606781,
     -15987176,
     -23868391,
     -7146981,
     -714723,
     -24913887,
     -29787612,
     -29921755,
     -18586578,
     -18195363,
     -7751120,
     -14127564,
     -14216139,
     -1551095,
     -13190600,
     -2000327,
     -29003937,
     -27562944,
     -11009460,
     -5487024,
     -4314541,
     -29554089,
     -10827176,
     -2600871,
     -499621,
     -17934756,
     -15210403,
     -9126815,
     -5822877,
     -23275420,
     -3399066,
     -18469274,
     -24835481,
     -4829591,
     -3344276,
     -22609389,
     -11014818,
     -10048066,
     -15739785,
     -9104775,
     -23482756,
     -5603713,
     -21966912,
     -15958396,
     -1967481,
     -4546423,
     -10621814,
     -29518707,
     -2431857,
     -15586157,
     -5205865,
     -23239528,
     -22055057,
     -27415396,
     -1472354,
     -25156445,
     -14297947,
     -18219354,
     -1826647,
     -29999953,
     -4739407,
     -3328846,
     -11026061,
     -13106503,
     -16817475,
     -24915233,
     -14566720,
     -25671996,
     -489786,
     -12466399,
     -27352376,
     -15195442,
     -25755440,
     -6064942,
     -1071892,
     -27269417,
     -3889957,
     -16017542,
     -17328603,
     -10279200,
     -29286172,
     -21558552,
     -21371670,
     -20308756,
     -385811,
     -24163088,
     -14967566,
     -25007371,
     -15721735,
     -20560134,
     -9472771,
     -25835265,
     -19036928,
     -4956926,
     -22068988,
     -20794615,
     -10001619,
     -21456112,
     -18560552,
     -4256493,
     -29660908,
     -5237995,
     -12481770,
     -19714281,
     -16313575,
     -26298083,
     -1936610,
     -8070881,
     -20296928,
     -15191775,
     -22287062,
     -23404756,
     -1731795,
     -24589522,
     -14133967,
     -11744460,
     -4666743,
     -15208645,
     -17427652,
     -22443382,
     -26117152,
     -21813947,
     -25205434,
     -10554553,
     -20280517,
     -7896754,
     -12235951,
     -29802158,
     -25870701,
     -11901099,
     -5896362,
     -7991464,
     -21292194,
     -2142691,
     -9366173,
     -4881945,
     -1319059,
     -5035153,
     -19235472,
     -27208335,
     -4588686,
     -29999981,
     -9608331,
     -4320905,
     -4551816,
     -27042439,
     -11889286,
     -5082245,
     -7306723,
     -1344128,
     -1454528,
     -4383355,
     -28298361,
     -866936,
     -23617300,
     -426345,
     -13519987,
     -6568723,
     -14930280,
     -16421998,
     -747629,
     -586435,
     -26405482,
     -16654438,
     -18138213,
     -18138212,
     -10489955,
     -19229792,
     -5085791,
     -7140955,
     -4350042,
     -9329747,
     -29910097,
     -25608784,
     -2390606,
     -7019594,
     -5971127,
     -29196872,
     -14968389,
     -28252480,
     -8947266,
     -15643200,
     -23614766,
     -3544119,
     -15290932,
     -12183560,
     -29473839,
     -2382379,
     -11365928,
     -3075620,
     -9606178,
     -5114971,
     -24252960,
     -4842525,
     -4331548,
     -2578459,
     -4881946,
     -16129561,
     -27484181,
     -27504657,
     -15813101,
     -20171279,
     -16311306,
     -27232834,
     -10694664,
     -10596869,
     -3945476,
     -17963011,
     -11044129])
x = multiAlignReads(list(readsid),r)
xxx = x.values()[3]
c = consensus(xxx,r,covmin=5)
asm = Assembler(r)
s = insertFragment(asm,c)
s = [(i,(None,)) for i in s]
a = tango(asm,s,mincov=1,minread=3,minoverlap=30)
asm.cleanDeadBranches()
cg = asm.compactAssembling()

def getAllPairedRead(self): 
    '''
    
    :param assgraph:
    :type assgraph:
    :param stemid:
    :type stemid:
    :param back:
    :type back:
    :param end:
    :type end:
    '''
    
    path=list(self.graph)
    reads = [(i,) + r.getIds(i) for i in path if i <= len(r)]
    reads=[i[3] if i[0] in i[3] else set(-j for j in i[3]) for i in reads]
    paired=[(r.getPairedRead(j) for j in i) for i in reads]
    paired=[[(j,) + r.getIds(j) for j in i if j!=0] for i in paired]
    paired = [[j[1] if j[0] in j[3] else -j[1] for j in i] for i in paired]
    paired = set(reduce(lambda a,b: a+b,(i for i in paired)))
    return paired

