#! /usr/bin/env python
#
# Install script
#
#

import sys
import os
import os.path
import re
import glob

from os import path

#
# Add to the python path the directory containing the extensions
# of distutils
#

sys.path.append('distutils.ext')

from obidistutils.core import setup
from obidistutils.core import CTOOLS
from obidistutils.core import CEXES



VERSION =  "00.01.000"
AUTHOR  = 'Eric Coissac'
EMAIL   = 'eric@coissac.eu'
URL     = 'www.grenoble.prabi.fr/trac/OBITools'
LICENSE = 'CeCILL-V2'

SRC                = 'python'
CSRC               = 'src'

DEPRECATED_SCRIPTS=[
                   ]

CTOOLS.extend([('littlebigman',{"sources":["src/littlebigman.c"]}),
               ('buildcomplement',{"sources":["src/buildcomplement.c"]}),
               ('buildcode',{"sources":["src/buildcode.c"]})])


CEXES.extend([('orgasmi',{"sources":["src/orgasmi.c",
                                     "src/buffer.c",
                                     "src/buildindex.c",
                                     "src/code16bits.c",
                                     "src/codecomp.c",
                                     "src/compsort.c",
                                     "src/debug.c",
                                     "src/decode.c",
                                     "src/encode.c",
                                     "src/fastq.c",
                                     "src/indexinput.c",
                                     "src/indexoutput.c",
                                     "src/load.c",
                                     "src/lookfor.c",
                                     "src/malloc.c",
                                     "src/sort.c"
                                     ]})])    
    
setup(name="ORG.asm",
      description="Scripts and library for organelle assembling",
      version=VERSION,
      author=AUTHOR,
      author_email=EMAIL,
      license=LICENSE,
      url=URL,
      python_src=SRC)
